--
-- Copyright (c) 2013 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Interfaces.C;                      use Interfaces.C;
with Interfaces.C.Strings;              use Interfaces.C.Strings;

package body Allegro.Keyboard is

    function Al_Install_Keyboard return Boolean is

        function C_Al_Install_Keyboard return Bool;
        pragma Import( C, C_Al_Install_Keyboard, "al_install_keyboard" );

    begin
        return To_Ada( C_Al_Install_Keyboard );
    end Al_Install_Keyboard;

    ----------------------------------------------------------------------------

    function Al_Is_Keyboard_Installed return Boolean is

        function C_Al_Is_Keyboard_Installed return Bool;
        pragma Import( C, C_Al_Is_Keyboard_Installed, "al_is_keyboard_installed" );

    begin
        return To_Ada( C_Al_Is_Keyboard_Installed );
    end Al_Is_Keyboard_Installed;

    ----------------------------------------------------------------------------

    function Al_Set_Keyboard_Leds( leds : Integer ) return Boolean is

        function C_Al_Set_Keyboard_Leds( leds : Integer ) return Bool;
        pragma Import( C, C_Al_Set_Keyboard_Leds, "al_set_keyboard_leds" );

    begin
        return To_Ada( C_Al_Set_Keyboard_Leds( leds ) );
    end Al_Set_Keyboard_Leds;

    ----------------------------------------------------------------------------

    function Al_Keycode_To_Name( keycode : Integer ) return String is

        function C_Al_Keycode_To_Name( keycode : Integer ) return C.Strings.chars_ptr;
        pragma Import( C, C_Al_Keycode_To_Name, "al_keycode_to_name" );

    begin
        return To_Ada( Value( C_Al_Keycode_To_Name( keycode ) ) );
    end Al_Keycode_To_Name;

    ----------------------------------------------------------------------------

    function Al_Key_Down( state   : Allegro_Keyboard_State;
                          keycode : Integer ) return Boolean is

        function C_Al_Key_Down( state   : access Allegro_Keyboard_State;
                                keycode : Integer ) return Bool;
        pragma Import( C, C_Al_Key_Down, "al_key_down" );

    begin
        return To_Ada( C_Al_Key_Down( state'Unrestricted_Access, keycode ) );
    end Al_Key_Down;

end Allegro.Keyboard;
