--
-- Copyright (c) 2013 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Interfaces;                        use Interfaces;
with Interfaces.C;                      use Interfaces.C;

-- Allegro 5.0.9 - Time routines
package Allegro.Time is

    type Allegro_Timeout is private;

    function Al_Get_Time return double;
    pragma Import( C, Al_Get_Time, "al_get_time" );

    function Al_Current_Time return double renames Al_Get_Time;

    procedure Al_Init_Timeout( timeout : in out Allegro_Timeout; seconds : double );
    pragma Import( C, Al_Init_Timeout, "al_init_timeout" );

    procedure Al_Rest( seconds : double );
    pragma Import( C, Al_Rest, "al_rest" );

private

    type Allegro_Timeout is
        record
            pad1 : Unsigned_64;
            pad2 : Unsigned_64;
        end record;
    pragma Convention( C, Allegro_Timeout );

end Allegro.Time;
