
with Ada.Unchecked_Deallocation;

package body Completions is

    protected body Completion is

        procedure Notify_Complete is
        begin
            complete := True;
        end Notify_Complete;

        ------------------------------------------------------------------------

        function Is_Complete return Boolean is
        begin
            return complete;
        end Is_Complete;

        ------------------------------------------------------------------------

        entry Wait when complete is
        begin
            null;
        end Wait;

    end Completion;

    ----------------------------------------------------------------------------

    procedure Delete( obj : in out A_Completion ) is
        procedure Free is new Ada.Unchecked_Deallocation( Completion, A_Completion );
    begin
        Free( obj );
    end Delete;

end Completions;
