--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Ada.Command_Line;                  use Ada.Command_Line;
with Allegro;                           use Allegro;
with Applications;                      use Applications;
with Debugging;                         use Debugging;
with Objects;
with Project;

pragma Elaborate_All( Allegro );

-- The Project package is not used here but it must be referenced to ensure its
-- compilation.
pragma Warnings( off, Project );

package body Engine is

    procedure Main is
        stat : Integer := 0;
    begin
        Create_Application;
        Run_Application( stat );
        Delete_Application;

        pragma Debug( Objects.Display_Instance_Counts );

        Set_Exit_Status( Exit_Status(stat) );
    exception
        when e : others =>
            pragma Debug( Dbg( "Engine.Main Exception: ..." ) );
            pragma Debug( Dbg( e ) );
            Set_Exit_Status( Failure );
    end Main;

begin
    Set_Ada_Main( Main'Access );
end Engine;
