--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Hashed_Strings;                    use Hashed_Strings;

package Engine_Debugging is

    type Hashed_String_Array is array (Positive range <>) of Hashed_String;

    Systems : constant Hashed_String_Array := (
        To_Hashed_String( "audio" ),
        To_Hashed_String( "entities" ),
        To_Hashed_String( "eval" ),
        To_Hashed_String( "events" ),
        To_Hashed_String( "game" ),
        To_Hashed_String( "gui" ),
        To_Hashed_String( "init" ),
        To_Hashed_String( "input" ),
        To_Hashed_String( "physics" ),
        To_Hashed_String( "prefs" ),
        To_Hashed_String( "procs" ),
        To_Hashed_String( "res" ),
        To_Hashed_String( "tiles" ),
        To_Hashed_String( "view" ),
        To_Hashed_String( "mem" )
    );

    D_AUDIO    : constant Hashed_String := Systems(1);
    D_ENTITIES : constant Hashed_String := Systems(2);
    D_EVAL     : constant Hashed_String := Systems(3);
    D_EVENTS   : constant Hashed_String := Systems(4);
    D_GAME     : constant Hashed_String := Systems(5);
    D_GUI      : constant Hashed_String := Systems(6);
    D_INIT     : constant Hashed_String := Systems(7);
    D_INPUT    : constant Hashed_String := Systems(8);
    D_PHYSICS  : constant Hashed_String := Systems(9);
    D_PREFS    : constant Hashed_String := Systems(10);
    D_PROCS    : constant Hashed_String := Systems(11);
    D_RES      : constant Hashed_String := Systems(12);
    D_TILES    : constant Hashed_String := Systems(13);
    D_VIEW     : constant Hashed_String := Systems(14);
    D_MEM      : constant Hashed_String := Systems(15);

end Engine_Debugging;
