--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Events.Manager;

package body Events.Audio is

    overriding
    procedure Construct( this : access Play_Music_Event; name : String ) is
    begin
        Event(this.all).Construct( "Play_Music" );
        this.name := To_Unbounded_String( name );
    end Construct;

    ----------------------------------------------------------------------------

    function Get_Music_Name( this : not null access Play_Music_Event'Class ) return String is
    begin
        return To_String( this.name );
    end Get_Music_Name;

    ----------------------------------------------------------------------------

    overriding
    function To_String( this : access Play_Music_Event ) return String is
    begin
        return '<' & this.Get_Name & " - '" & To_String( this.name ) & "'>";
    end To_String;

    --==========================================================================

    overriding
    procedure Construct( this : access Play_Sound_Event; name : String ) is
    begin
        Event(this.all).Construct( "Play_Sound" );
        this.name := To_Unbounded_String( name );
    end Construct;

    ----------------------------------------------------------------------------

    function Get_Sound_Name( this : not null access Play_Sound_Event'Class ) return String is
    begin
        return To_String( this.name );
    end Get_Sound_Name;

    ----------------------------------------------------------------------------

    overriding
    function To_String( this : access Play_Sound_Event ) return String is
    begin
        return '<' & this.Get_Name & " - '" & To_String( this.name ) & "'>";
    end To_String;

    --==========================================================================

    procedure Queue_Play_Music( name : String ) is
        evt : A_Play_Music_Event := new Play_Music_Event;
    begin
        evt.Construct( name );
        Events.Manager.Queue_Event( A_Event(evt) );
    end Queue_Play_Music;

    ----------------------------------------------------------------------------

    procedure Queue_Play_Sound( name : String ) is
        evt : A_Play_Sound_Event := new Play_Sound_Event;
    begin
        evt.Construct( name );
        Events.Manager.Queue_Event( A_Event(evt) );
    end Queue_Play_Sound;

    ----------------------------------------------------------------------------

    procedure Queue_Stop_Music is
        evt : A_Event := new Event;
    begin
        evt.Construct( "Stop_Music" );
        Events.Manager.Queue_Event( evt );
    end Queue_Stop_Music;

end Events.Audio;
