--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Allegro.Fonts.TTF;                 use Allegro.Fonts.TTF;
with Debugging;                         use Debugging;
with Engine_Debugging;                  use Engine_Debugging;

package body Fonts.Manager is

    initialized,
    finalized   : Boolean := False;

    -- END PRIVATE DECLARATIONS --
    --==========================================================================

    procedure Initialize is
    begin
        if not initialized then
            pragma Debug( Dbg( "Initializing font system", D_INIT, INFO ) );
            Al_Init_Font_Addon;
            if not Al_Init_TTF_Addon then
                raise FONT_EXCEPTION with "Allegro TTF addon failed to initialize";
            end if;
            initialized := True;
        end if;
    end Initialize;

    ----------------------------------------------------------------------------

    procedure Finalize is
    begin
        if initialized and then not finalized then
            pragma Debug( Dbg( "Finalizing font system", D_INIT, INFO ) );
            Al_Shutdown_TTF_Addon;
            Al_Shutdown_Font_Addon;
            finalized := True;
        end if;
    end Finalize;

end Fonts.Manager;
