--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Locking_Objects is

    protected body Locking_Object is

        entry Lock( owner : Task_Id := Current_Task ) when lockingTask = Null_Task_Id is
        begin
            lockingTask := owner;
        end Lock;

        procedure Unlock is
        begin
            if lockingTask /= Current_Task then
                if lockingTask = Null_Task_Id then
                    raise LOCK_USE_EXCEPTION with "Object has not been locked";
                else
                    raise LOCK_USE_EXCEPTION with "Caller does not own lock";
                end if;
            end if;
            lockingTask := Null_Task_Id;
        end Unlock;

    end Locking_Object;

end Locking_Objects;
