--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Allegro.Color;                     use Allegro.Color;

package Physics.Drawing is

    -- Draws the clipping shape of a tile at x, y on the drawing target. The
    -- clipping shape is determined by the tile's clipping type in 'cType'.
    -- 'size' is the width/height of the tile in pixels.
    procedure Draw( cType : Clip_Type;
                    x, y  : Integer;
                    size  : Positive;
                    color : Allegro_Color );

end Physics.Drawing;
