--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Scripting.Expressions.Variables is

    function Create_Variable( token : not null A_Identifier_Token ) return A_Variable is
        this : constant A_Variable := new Variable;
    begin
        this.Construct( token.Get_Location, token.Get_Name );
        return this;
    end Create_Variable;

    ----------------------------------------------------------------------------

    not overriding
    procedure Construct( this : access Variable; loc : Token_Location; name : String ) is
    begin
        Expression(this.all).Construct( loc );
        this.name := To_Unbounded_String( name );
    end Construct;

    ----------------------------------------------------------------------------

    overriding
    function Evaluate( this    : access Variable;
                       context : not null A_Eval_Context ) return Value_Ptr is
    begin
        return context.Evaluate_Symbol( To_String( this.name ) );
    end Evaluate;

end Scripting.Expressions.Variables;
