--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Scripting.Expressions is

    not overriding
    procedure Construct( this : access Expression; loc : Token_Location ) is
    begin
        Limited_Object(this.all).Construct;
        this.loc := loc;
    end Construct;

    ----------------------------------------------------------------------------

    procedure Delete( this : in out A_Expression ) is
    begin
        Delete( A_Limited_Object(this) );
    end Delete;

    --==========================================================================

    procedure Delete_Contents( expressions : in out Expression_Lists.List ) is
        pos : Expression_Lists.Cursor := expressions.First;
        e   : A_Expression;
    begin
        while Expression_Lists.Has_Element( pos ) loop
            e := Expression_Lists.Element( pos );
            Delete( e );
            pos := Expression_Lists.Next( pos );
        end loop;
        expressions.Clear;
    end Delete_Contents;

end Scripting.Expressions;
