--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Scripting.Expressions;             use Scripting.Expressions;

package body Scripting.Statements.Methods is

    function Create_Method return A_Method is
    begin
        return new Method;
    end Create_Method;

    ----------------------------------------------------------------------------

    overriding
    procedure Delete( this : in out Method ) is
    begin
        Delete( A_Expression(this.func) );
        Statement(this).Delete;
    end Delete;

    ----------------------------------------------------------------------------

    overriding
    procedure Evaluate( this    : access Method;
                        context : not null A_Eval_Context ) is
        result : Value_Ptr;
        pragma Warnings( Off, result );
    begin
        result := this.func.Evaluate( context );       -- may raise exception
    end Evaluate;

    ----------------------------------------------------------------------------

    procedure Set_Function( this : not null access Method'Class;
                            func : not null A_Function ) is
    begin
        this.func := func;
    end Set_Function;

end Scripting.Statements.Methods;
