--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Scripting.Statements is

    procedure Delete( this : in out A_Statement ) is
    begin
        Delete( A_Limited_Object(this) );
    end Delete;

    --==========================================================================

    procedure Delete_Contents( statements : in out Statement_Lists.List ) is
        pos : Statement_Lists.Cursor := statements.First;
        s   : A_Statement;
    begin
        while Statement_Lists.Has_Element( pos ) loop
            s := Statement_Lists.Element( pos );
            Delete( s );
            pos := Statement_Lists.Next( pos );
        end loop;
        statements.Clear;
    end Delete_Contents;

end Scripting.Statements;
