--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Ada.Strings;                       use Ada.Strings;
with Ada.Strings.Fixed;                 use Ada.Strings.Fixed;
with Ada.Calendar;                      use Ada.Calendar;
with Ada.Calendar.Formatting;
with Ada.Calendar.Time_Zones;

package body Version is

    function Release return String is
    begin
#if VERSION'Defined then
        return $VERSION;
#else
        return "0.0.0";
#end if;
    end Release;

    ----------------------------------------------------------------------------

    function Copyright_Year return String is
    begin
        -- $BUILD_TIME is the build time in UTC
        return
            Trim(
                Year_Number'Image(
                    Ada.Calendar.Formatting.Year(
#if BUILD_TIME'Defined then
                        Time'(Ada.Calendar.Formatting.Value( $BUILD_TIME )),
#else
                        Ada.Calendar.Clock,
#end if;
                        Time_Zone => Ada.Calendar.Time_Zones.UTC_Time_Offset
                    )
                ),
                Left
            );
    end Copyright_Year;

end Version;
