--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Widgets.Buttons.Groups.Simple_Listeners is

    function Listener( id      : Action_Id;
                       obj     : access Target'Class;
                       handler : not null A_Handler ) return A_Button_Group_Listener is
        this : constant A_Button_Group_Listener := new Simple_Button_Group_Listener;
    begin
        Simple_Button_Group_Listener(this.all).Construct;
        Simple_Button_Group_Listener(this.all).id := id;
        Simple_Button_Group_Listener(this.all).object := obj;
        Simple_Button_Group_Listener(this.all).handler := handler;
        return this;
    end Listener;

    ----------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this   : access Simple_Button_Group_Listener;
                             action : A_Button_Group_Action ) is
    begin
        if action.Get_Id = this.id then
            this.handler( this.object, action );
        end if;
    end Handle_Action;

end Widgets.Buttons.Groups.Simple_Listeners;
