--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Widgets.Buttons.Simple_Listeners is

    function Listener( id      : Action_Id;
                       obj     : access Target'Class;
                       handler : not null A_Handler1 ) return A_Button_Listener is
        this : constant A_Button_Listener := new Simple_Button_Listener;
    begin
        Simple_Button_Listener(this.all).Construct;
        Simple_Button_Listener(this.all).id := id;
        Simple_Button_Listener(this.all).object := obj;
        Simple_Button_Listener(this.all).handler1 := handler;
        return this;
    end Listener;

    ------------------------------------------------------------------------

    function Listener( id      : Action_Id;
                       obj     : access Target'Class;
                       handler : not null A_Handler2 ) return A_Button_Listener is
        this : constant A_Button_Listener := new Simple_Button_Listener;
    begin
        Simple_Button_Listener(this.all).Construct;
        Simple_Button_Listener(this.all).id := id;
        Simple_Button_Listener(this.all).object := obj;
        Simple_Button_Listener(this.all).handler2 := handler;
        return this;
    end Listener;

    ------------------------------------------------------------------------

    function Listener( obj     : access Target'Class;
                       handler : not null A_Handler1 ) return A_Button_Listener is
    begin
        return Listener( Click, obj, handler );
    end Listener;

    ------------------------------------------------------------------------

    function Listener( obj     : access Target'Class;
                       handler : not null A_Handler2 ) return A_Button_Listener is
    begin
        return Listener( Click, obj, handler );
    end Listener;

    ------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this   : access Simple_Button_Listener;
                             action : A_Button_Action ) is
    begin
        if action.Get_Id = this.id then
            if this.handler1 /= null then
                this.handler1( this.object );
            else
                this.handler2( this.object, action );
            end if;
        end if;
    end Handle_Action;

end Widgets.Buttons.Simple_Listeners;
