--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Allegro.Keyboard;                  use Allegro.Keyboard;
--with Debugging;                         use Debugging;
with Mouse;                             use Mouse;

package body Widgets.Buttons.Toggles is

    function Create_Toggle_Button( view : not null access Game_Views.Game_View'Class;
                                   id   : String;
                                   text : String := "";
                                   icon : String := "" ) return A_Button is
        this : A_Toggle_Button := new Toggle_Button;
    begin
        this.Construct( view, id, text, icon );
        return A_Button(this);
    exception
        when others =>
            Delete( A_Widget(this) );
            raise;
    end Create_Toggle_Button;

    ----------------------------------------------------------------------------

    overriding
    procedure On_Key_Press( this    : access Toggle_Button;
                            evt     : not null A_Key_Event;
                            handled : in out Boolean ) is
    begin
        if evt.Get_Key = ALLEGRO_KEY_SPACE or else
           evt.Get_Key = ALLEGRO_KEY_ENTER or else
           evt.Get_Key = ALLEGRO_KEY_PAD_ENTER
        then
            this.Set_State( not this.on );
            handled := True;
        end if;
    end On_Key_Press;

    ----------------------------------------------------------------------------

    overriding
    procedure On_Mouse_Press( this : access Toggle_Button;
                              evt  : not null A_Mouse_Button_Event ) is
    begin
        if evt.Get_Button = Mouse_Left then
            this.Set_State( not this.on );
        end if;
    end On_Mouse_Press;

end Widgets.Buttons.Toggles;
