--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Widgets.Menu_Items.Simple_Listeners is

    function Listener( id      : Action_Id;
                       obj     : access Target'Class;
                       handler : not null A_Handler ) return A_Menu_Listener is
        this : constant A_Menu_Listener := new Simple_Menu_Listener;
    begin
        Simple_Menu_Listener(this.all).Construct;
        Simple_Menu_Listener(this.all).id := id;
        Simple_Menu_Listener(this.all).object := obj;
        Simple_Menu_Listener(this.all).handler := handler;
        return this;
    end Listener;

    ----------------------------------------------------------------------------

    function Listener( obj     : access Target'Class;
                       handler : not null A_Handler ) return A_Menu_Listener is
    begin
        return Listener( Menu_Selected, obj, handler );
    end Listener;

    ----------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this   : access Simple_Menu_Listener;
                             action : A_Menu_Action ) is
    begin
        if action.Get_Id = this.id then
            this.handler( this.object, action );
        end if;
    end Handle_Action;

end Widgets.Menu_Items.Simple_Listeners;
