--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Widgets.Simple_Key_Listeners is

    function Listener( key       : Integer;
                       modifiers : Modifiers_Pattern;
                       id        : Action_Id;
                       obj       : access Target'Class;
                       handler   : A_Handler ) return A_Key_Listener is
        this : constant A_Key_Listener := new Simple_Key_Listener;
    begin
        Simple_Key_Listener(this.all).Construct;
        Simple_Key_Listener(this.all).key := key;
        Simple_Key_Listener(this.all).modifiers := modifiers;
        Simple_Key_Listener(this.all).id := id;
        Simple_Key_Listener(this.all).object := obj;
        Simple_Key_Listener(this.all).handler := handler;
        return this;
    end Listener;

    ----------------------------------------------------------------------------

    function Listener( key     : Integer;
                       id      : Action_Id;
                       obj     : access Target'Class;
                       handler : A_Handler ) return A_Key_Listener is
    begin
        return Listener( key, MODIFIERS_ANY, id, obj, handler );
    end Listener;

    ----------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this    : access Simple_Key_Listener;
                             action  : A_Key_Action;
                             handled : out Boolean ) is
    begin
        if action.Get_Id = this.id and then
           action.Get_Key = this.key and then
           action.Get_Modifiers = this.modifiers
        then
            handled := True;
            this.handler( this.object, action );
        else
            handled := False;
        end if;
    end Handle_Action;

end Widgets.Simple_Key_Listeners;
