--
-- Copyright (c) 2013 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

with Allegro.Bitmaps;                   use Allegro.Bitmaps;

package xBR is

    -- Initialize must be called before any of the scaling procedures below.
    -- Calling this more than once will have no effect.
    procedure Initialize;

    -- 2xBR v3.3a (Square style)
    --
    -- The dimensions of 'output' must be large enough to contain 'input' when
    -- scaled by 2x and drawn onto 'output' at 'destX','destY'.
    procedure xBR2( input, output : not null A_Allegro_Bitmap;
                    destX, destY  : Integer );

    -- 3xBR v3.3a (Square style)
    --
    -- The dimensions of 'output' must be large enough to contain 'input' when
    -- scaled by 3x and drawn onto 'output' at 'destX','destY'.
    procedure xBR3( input, output : not null A_Allegro_Bitmap;
                    destX, destY  : Integer );

    -- 4xBR v3.3a (Square style)
    --
    -- The dimensions of 'output' must be large enough to contain 'input' when
    -- scaled by 4x and drawn onto 'output' at 'destX','destY'.
    procedure xBR4( input, output : not null A_Allegro_Bitmap;
                    destX, destY  : Integer );

end xBR;
