--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Tools;
private with Tools.Pointers;

package Games.Sessions.Ked is

private

    use Tools;
    use Tools.Pointers;

    type Ked_Session is new Game_Session with
        record
            tool : A_Tool := Create_Pointer;
        end record;

    procedure Delete( this : in out Ked_Session );

    procedure Handle_Event( this : access Ked_Session;
                            evt  : in out A_Event;
                            resp : out Response_Type );
    pragma Precondition( evt /= null );

    procedure On_New_Game( this : access Ked_Session );

    procedure On_End_Game( this      : access Ked_Session;
                           completed : Boolean );

end Games.Sessions.Ked;
