--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

--with Debugging;                         use Debugging;
with Events.Ked;                        use Events.Ked;
with Tools.Paintbrushes;                use Tools.Paintbrushes;

package body Tools.Pointers is

    function Create_Pointer return A_Tool is
        this : constant A_Tool := new Pointer;
    begin
        this.Construct;
        return this;
    end Create_Pointer;

    ----------------------------------------------------------------------------

    overriding
    procedure Apply( this : access Pointer; context : Tool_Context ) is
        pragma Unreferenced( this );
        tw   : constant Positive := context.world.Tile_Width;
        tool : A_Tool;
        tile : Integer;
    begin
        if context.first and then context.func = Secondary then
            tile := context.world.Get_Tile_Id( context.layer,
                                               context.worldX / tw,
                                               context.worldY / tw );
            tool := Create_Paintbrush( tile );
            Queue_Set_Tool( tool );
            Delete( tool );
        end if;
    end Apply;

    ----------------------------------------------------------------------------

    overriding
    function Get_Type( this : access Pointer ) return Tool_Type is
        pragma Unreferenced( this );
    begin
        return Pointer_Tool;
    end Get_Type;

end Tools.Pointers;
