--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Widgets.Buttons;

package Widgets.Containers.Panels.Dialogs.Import_World is

    function Create_Import_Dialog( view : not null access Game_Views.Game_View'Class;
                                   id   : String ) return A_Dialog;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Import_Dialog'Result /= null );

private

    use Widgets.Buttons;

    type Import_Dialog is new Dialog and Button_Listener with null record;

    procedure Construct( this : access Import_Dialog;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Handle_Action( this   : access Import_Dialog;
                             action : A_Button_Action );

    procedure Handle_Action( this    : access Import_Dialog;
                             action  : A_Key_Action;
                             handled : out Boolean );

    procedure On_Dialog_Show( this : access Import_Dialog );

    procedure Show( this : access Import_Dialog );

end Widgets.Containers.Panels.Dialogs.Import_World;
