--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Events;
private with Events.Listeners;
private with Widgets.Buttons;

package Widgets.Containers.Panels.Dialogs.Properties is

    function Create_Properties_Dialog( view : not null access Game_Views.Game_View'Class;
                                       id   : String ) return A_Dialog;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Properties_Dialog'Result /= null );

private

    use Events;
    use Events.Listeners;
    use Widgets.Buttons;

    type Properties_Dialog is new Dialog and
         Button_Listener and
         Event_Listener with null record;

    procedure Construct( this : access Properties_Dialog;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Delete( this : in out Properties_Dialog );

    procedure Handle_Action( this   : access Properties_Dialog;
                             action : A_Button_Action );

    procedure Handle_Action( this    : access Properties_Dialog;
                             action  : A_Key_Action;
                             handled : out Boolean );

    procedure Handle_Event( this : access Properties_Dialog;
                            evt  : in out A_Event;
                            resp : out Response_Type );
    pragma Precondition( evt /= null );

    procedure On_Dialog_Hide( this : access Properties_Dialog );

    procedure On_Dialog_Show( this : access Properties_Dialog );

    procedure Show( this : access Properties_Dialog );

end Widgets.Containers.Panels.Dialogs.Properties;
