--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Widgets.Buttons;

package Widgets.Containers.Panels.Dialogs.Save_Changes is

    function Create_Save_Changes_Dialog( view : not null access Game_Views.Game_View'Class;
                                         id   : String ) return A_Dialog;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Save_Changes_Dialog'Result /= null );

private

    use Widgets.Buttons;

    type Save_Changes_Dialog is new Dialog and Button_Listener with null record;

    procedure Construct( this : access Save_Changes_Dialog;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Handle_Action( this   : access Save_Changes_Dialog;
                             action : A_Button_Action );

    procedure Handle_Action( this    : access Save_Changes_Dialog;
                             action  : A_Key_Action;
                             handled : out Boolean );

    procedure Show( this : access Save_Changes_Dialog );

end Widgets.Containers.Panels.Dialogs.Save_Changes;
