--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Games.Sessions.Keen is

private

    type Keen_Session is new Game_Session with
        record
            dialogId : Integer := Integer'First;    -- current open dialog
        end record;

    procedure Handle_Event( this : access Keen_Session;
                            evt  : in out A_Event;
                            resp : out Response_Type );
    pragma Precondition( evt /= null );

    procedure On_Load_World( this : access Keen_Session; filename : String );

    procedure On_New_Game( this : access Keen_Session );

    procedure On_End_Game( this      : access Keen_Session;
                           completed : Boolean );

end Games.Sessions.Keen;
