--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Tiles.Libraries;

package Themes.Keen is

    pragma Elaborate_Body;

private

    use Tiles.Libraries;

    type Keen_Theme is new Theme with
        record
            lib : A_Tile_Library := null;
        end record;

    procedure Construct( this : access Keen_Theme );

    procedure Delete( this : in out Keen_Theme );

    function Get_Bitmap( this : access Keen_Theme;
                         id   : Natural ) return A_Allegro_Bitmap;

    function Get_ID( this : access Keen_Theme; name : String ) return Natural;
    pragma Precondition( name'Length > 0 );

    function Get_Tile( this : access Keen_Theme; id : Natural ) return A_Tile;

end Themes.Keen;
