--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Widgets.Buttons.Pushes.Retry_Buttons is

    -- Retry_Button widgets are used on the retry level dialog of the
    -- Retry_Screen. They are animated and have a specific look to match the
    -- dialog box.
    type Retry_Button is new Push_Button and Animated with private;
    type A_Retry_Button is access all Retry_Button'Class;

    -- Creates a new button specifically for use in the retry level dialog box.
    function Create_Retry_Button( view : not null access Game_Views.Game_View'Class;
                                  id   : String;
                                  text : String := "";
                                  icon : String := "" ) return A_Button;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Retry_Button'Result /= null );

private

    type Retry_Button is new Push_Button and Animated with null record;

    procedure Construct( this : access Retry_Button;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String;
                         text : String;
                         icon : String );
    pragma Precondition( id'Length > 0 );

    procedure Draw_Content( this : access Retry_Button );

    procedure On_Key_Press( this    : access Retry_Button;
                            evt     : not null A_Key_Event;
                            handled : in out Boolean );

    procedure Tick( this : access Retry_Button; time : Tick_Time );

end Widgets.Buttons.Pushes.Retry_Buttons;
