--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Widgets.Containers.Game_Screens.Menus.Config is

    -- The config screen represents Keen's configuration menu, accessible from
    -- the main menu.
    type Config_Screen is new Menu_Screen with private;

    -- Creates a new configuration menu screen.
    function Create_Config_Screen( view : not null access Game_Views.Game_View'Class;
                                   id   : String ) return A_Game_Screen;

private

    type Config_Screen is new Menu_Screen with null record;

    procedure Construct( this : access Config_Screen;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );

    -- Focuses the top menu item on activation.
    procedure Activate( this : access Config_Screen ) ;

end Widgets.Containers.Game_Screens.Menus.Config;
