--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Widgets.Containers.Game_Screens.Retry is

    -- The retry screen is shown when Keen dies, to ask the player if he wants
    -- to try the level again or return to the map.
    type Retry_Screen is new Game_Screen with private;

    -- Creates a new retry level screen.
    function Create_Retry_Screen( view      : not null access Game_Views.Game_View'Class;
                                  id        : String;
                                  dialogId  : Integer;
                                  levelName : String;
                                  yesText   : String;
                                  noText    : String ) return A_Game_Screen;

private

    type Retry_Screen is new Game_Screen with
        record
            -- the pending dialog id to send with the response event
            dialogId : Integer := 0;
        end record;

    procedure Construct( this      : access Retry_Screen;
                         view      : not null access Game_Views.Game_View'Class;
                         id        : String;
                         dialogId  : Integer;
                         levelName : String;
                         yesText   : String;
                         noText    : String ) ;

    procedure Activate( this : access Retry_Screen );

end Widgets.Containers.Game_Screens.Retry;
