--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

--with Debugging;                         use Debugging;
with Game_Views;                        use Game_Views;
with Widgets.Containers;                use Widgets.Containers;

package body Widgets.Containers.Game_Screens.Title is

    function Create_Title_Screen( view : not null access Game_Views.Game_View'Class;
                                  id   : String ) return A_Game_Screen is
        this : A_Game_Screen := new Title_Screen;
    begin
        this.Construct( view, id );
        return this;
    exception
        when others =>
            Delete( A_Widget(this) );
            raise;
    end Create_Title_Screen;

    ----------------------------------------------------------------------------

    overriding
    procedure Construct( this : access Title_Screen;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String ) is
    begin
        Game_Screen(this.all).Construct( view, id, popup => False );
        this.Set_Background( "title" );
        this.Add_Listener( A_Key_Listener(this) );
    end Construct;

    ----------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this    : access Title_Screen;
                             action  : A_Key_Action;
                             handled : out Boolean ) is
    begin
        if action.Get_Id = Key_Press then
            this.Exit_Screen;
        end if;
        handled := True;
    end Handle_Action;

end Widgets.Containers.Game_Screens.Title;
