--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Widgets.Containers.Game_Screens.Title is

    -- A title screen simply displays the game's splash screen and waits for
    -- any key to be pressed before exiting.
    type Title_Screen is new Game_Screen and Key_Listener with private;

    -- Creats a new title screen.
    function Create_Title_Screen( view : not null access Game_Views.Game_View'Class;
                                  id   : String ) return A_Game_Screen;

private

    type Title_Screen is new Game_Screen and Key_Listener with null record;

    procedure Construct( this : access Title_Screen;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );

    -- Exits the screen on any key press.
    procedure Handle_Action( this    : access Title_Screen;
                             action  : A_Key_Action;
                             handled : out Boolean );

end Widgets.Containers.Game_Screens.Title;
