--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

--private with Physics.Clip_Maps;

package Widgets.Containers.Scenes.Keen is

    function Create_Scene( view : not null access Game_Views.Game_View'Class;
                           id   : String ) return A_Scene;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Scene'Result /= null );

private

--    use Physics.Clip_Maps;

    type Keen_Scene is new Scene with null record;
--      record
--          clipMap : A_Clip_Map := null;
--      end record;

    procedure Construct( this : access Keen_Scene;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Delete( this : in out Keen_Scene );

    procedure Draw_Layer( this   : access Keen_Scene;
                          layer  : Positive;
                          startX,
                          startY : Integer;
                          tileX1,
                          tileY1,
                          tileX2,
                          tileY2 : Integer );
--
--  procedure Draw_Layer_Overlay( this   : access Keen_Scene;
--                                startX,
--                                startY : Integer;
--                                tileX1,
--                                tileY1,
--                                tileX2,
--                                tileY2 : Integer );
--

    procedure Handle_Event( this : access Keen_Scene;
                            evt  : in out A_Event;
                            resp : out Response_Type );
    pragma Precondition( evt /= null );

    procedure Handle_World_Loaded( this : access Keen_Scene;
                                   evt  : not null A_World_Loaded_Event );

    procedure Handle_World_Property_Changed( this : access Keen_Scene;
                                             evt  : not null A_World_Property_Event );

end Widgets.Containers.Scenes.Keen;
