--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package body Widgets.Progress_Boards.Simple_Listeners is

    function Listener( id      : Action_Id;
                       obj     : access Target'Class;
                       handler : not null A_Handler ) return A_PBoard_Listener is
        this : constant A_PBoard_Listener := new Simple_PBoard_Listener;
    begin
        Simple_PBoard_Listener(this.all).Construct;
        Simple_PBoard_Listener(this.all).id := id;
        Simple_PBoard_Listener(this.all).object := obj;
        Simple_PBoard_Listener(this.all).handler := handler;
        return this;
    end Listener;

    ------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this   : access Simple_PBoard_Listener;
                             action : A_PBoard_Action ) is
    begin
        if action.Get_Id = this.id then
            this.handler( this.object, action );
        end if;
    end Handle_Action;

end Widgets.Progress_Boards.Simple_Listeners;
