--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private package Entities.Players.Little_Keen.States is

    -- Returns a reference to the singleton State object for the corresponding
    -- Action_Type.
    function Get_State( action : Action_Type ) return A_State;
    pragma Postcondition( Get_State'Result /= null );

    ----------------------------------------------------------------------------

    type Moving_State is new State with null record;
    type Bored_State is new State with null record;

    function Get_Frame( this : Moving_State; k : Little_Keen'Class ) return Natural;
    function Get_Frame( this : Bored_State;  k : Little_Keen'Class ) return Natural;

    procedure Update( this : Moving_State; k : A_Little_Keen );
    procedure Update( this : Bored_State;  k : A_Little_Keen );

end Entities.Players.Little_Keen.States;
