--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Entities.Triggers.Keen is

    type Keen_Trigger is new Trigger with private;

private

    type Keen_Trigger is new Trigger with null record;

    procedure Construct( this : access Keen_Trigger );

    -- Called when the trigger's action script is executed
    function Evaluate_Function( this      : access Keen_Trigger;
                                name      : String;
                                arguments : Value_Array ) return Value_Ptr;

    function Object_Input( stream : access Root_Stream_Type'Class ) return Keen_Trigger;
    for Keen_Trigger'Input use Object_Input;

    procedure Object_Read( stream : access Root_Stream_Type'Class; obj : out Keen_Trigger );
    for Keen_Trigger'Read use Object_Read;

    procedure Object_Write( stream : access Root_Stream_Type'Class; obj : Keen_Trigger );
    for Keen_Trigger'Write use Object_Write;

end Entities.Triggers.Keen;
