--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

--with Debugging;                         use Debugging;
with Preferences;
with Worlds;

pragma Elaborate_All( Preferences );
pragma Elaborate_All( Worlds );

package body Worlds.Keen is

begin

    Register_Domain( "Map" );
    Preferences.Set_Default( "physics", "Map.friction_x", 700.0 );  -- 0.4
    Preferences.Set_Default( "physics", "Map.friction_y", 700.0 );  -- 0.4
    Preferences.Set_Default( "physics", "Map.gravity", 0.0 );
    Preferences.Set_Default( "physics", "Map.max_speed_x", 500.0 );
    Preferences.Set_Default( "physics", "Map.max_speed_y", 500.0 );

    Register_Domain( "Platform" );
    Preferences.Set_Default( "physics", "Platform.friction_x", 800.0 );  -- 0.6
    Preferences.Set_Default( "physics", "Platform.friction_y", 0.0 );
    Preferences.Set_Default( "physics", "Platform.gravity", 768.0 );
    Preferences.Set_Default( "physics", "Platform.max_speed_x", 140.0 );
    Preferences.Set_Default( "physics", "Platform.max_speed_y", 380.0 );

end Worlds.Keen;
