--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Tile_Operations is

    -- filename : Path to the image file to convert. Returns False on failure.
    function Convert_To_BMP_24( filename : String ) return Boolean;

    -- filename : Path to the image file to convert. Returns False on failure.
    function Convert_To_PNG( filename : String ) return Boolean;

    -- filename  : Tile sheet to use
    -- width     : Tile width
    -- spacing   : Spacing between tiles (no spacing at edges of the sheet!)
    -- skipEmpty : Skip tiles that completely transparent?
    -- prefix    : Path prefix for output images (default = .)
    -- format    : Output format of the images (default = same as filename)
    -- indexPath : Path of the tile index file to write (default = none)
    -- startId   : Tile id to start at in the generated index file
    -- minCols   : Minimum number of columns in tile index
    -- textOut   : Reporting procedure; may be null.
    procedure Cut( filename  : String;
                   width     : Positive;
                   spacing   : Natural := 0;
                   skipEmpty : Boolean := False;
                   prefix    : String := "";
                   format    : String := "";
                   indexPath : String := "";
                   startId   : Positive := 1;
                   minCols   : Positive := 1;
                   textOut   : access procedure( str : String ) );

end Tile_Operations;
